<?php
/*
Plugin Name: ImageMagick GPS
Version: 1.1
Description: Uses ImageMagick to read exif GPS data. (Plugin based on Exiftool GPS 0.7a)
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=858
Author: ZeBe
Author URI: http://piwigo.org/forum/profile.php?id=23420
*/

if (!defined('PHPWG_ROOT_PATH'))
{
	die('Hacking attempt!');
}

add_event_handler('format_exif_data', 'imagemagick_format_exif_data', EVENT_HANDLER_PRIORITY_NEUTRAL, 3);
function imagemagick_format_exif_data($exif, $filepath, $map)
{
	/* Check for existing GPS position data */
    $gpsExif = array_intersect_key($exif, array_flip(array('GPSLatitudeRef', 'GPSLatitude', 'GPSLongitudeRef', 'GPSLongitude')));
	if (count($gpsExif) == 4)
	{
		return $exif;
	}
	
	/* Create the object */
	$im = new imagick($filepath);

	/* Get the EXIF information */
	$exifGps = $im->getImageProperties("exif:GPS*");
  
	/* Get GPS Keys */
	$exifGpsKeys = array_keys($exifGps);
  
	$search = "exif:";
	$replace = "";
	
	foreach($exifGpsKeys as $gpsKey)
	{
		/* replace exif: from key */
		$gpsKeyStripped = str_replace($search, $replace, $gpsKey);
		
		/* skip some keys, probably not used in piwigo */
		switch ($gpsKeyStripped)
		{
			case "GPSAreaInformation":
			case "GPSProcessingMethod":
				continue 2;
		}
		
		$gpsValue = $exifGps[$gpsKey];
	  
		$gpsValueSplitted = explode(",",$gpsValue,4);
	
		$splittedCount = count($gpsValueSplitted);

		switch ($splittedCount)
		{
		case 3: 
			/* add position values as array to exif, gpstime is also splitted, probably not used */
			$exif[$gpsKeyStripped] = $gpsValueSplitted;
			break;
		default:
			/* add gps value to exif */
			$exif[$gpsKeyStripped] = $gpsValue;
		}
		
	}
  
	return $exif;
}
?>
